# Upgrade from 3.9.x to 3.9.5

### Upgrade from 3.9.4

#### gate-adding timeout

The retrofit timeout threshold values are now made as configurable. Below is the configuration that needs to be added in the gate config map.

```
retrofit: 
  connectTimeout: 30000 
  readTimeout: 30000 
  callTimeout: 30000 
  writeTimeout: 30000 
  retryOnConnectionFailure: true
```

Note: The default value is 30000 ms.

#### Common-gate updating the plugin URLs&#x20;

To enable Custom plugins for Verification, TestVerification, Approval and Policy, we need to add below in oes-gate-config under gate.yml.

```
spinnaker: 
  extensibility: 
    plugins: 
    deck-proxy: 
    enabled: true 
      plugins: 
        Opsmx.VerificationGatePlugin: 
          enabled: true 
          version: 1.0.1 
        Opsmx.TestVerificationGatePlugin: 
          enabled: true 
          version: 1.0.1 
        Opsmx.PolicyGatePlugin: 
          enabled: true 
          version: 1.0.1 
        Opsmx.VisibilityApprovalPlugin: 
          enabled: true 
          version: 1.0.1 
    repositories: 
      opsmx-repo: 
        url: file:///opt/spinnaker/plugins/plugins.json
```

Here plugin Zip file are already present inside image.

#### Spin-gate(gate-local.yml) updating the plugin URLs&#x20;

If we are not using common-gate in we have to add below config in gate-local.yml

```
spinnaker: 
  extensibility: 
    plugins: 
    deck-proxy: 
      enabled: true 
      plugins: 
        Opsmx.VerificationGatePlugin: 
          enabled: true 
          version: 1.0.1 
        Opsmx.TestVerificationGatePlugin: 
          enabled: true 
          version: 1.0.1 
        Opsmx.PolicyGatePlugin: 
          enabled: true 
          version: 1.0.1 
        Opsmx.VisibilityApprovalPlugin: 
          enabled: true 
          version: 1.0.1 
      repositories: 
        opsmx-repo: 
          url: https://raw.githubusercontent.com/opsmx/spinnakerPluginRepository/v3.10.0/plugins.json
```

#### Orca-local - remove the plugin-repo

Image to be used: quay.io/opsmxpublic/ubi8-oes-orca:2.20.4

```
spinnaker: 
  extensibility: 
    plugins: 
      Opsmx.VerificationGatePlugin: 
        enabled: true 
        version: 1.0.1 
      Opsmx.VisibilityApprovalPlugin: 
        enabled: true 
        version: 1.0.1 
      Opsmx.TestVerificationGatePlugin: 
        enabled: true 
        version: 1.0.1 
      Opsmx.PolicyGatePlugin: 
        enabled: true 
        version: 1.0.1
```

NOTE: please remove adding empty dir /opt/orca/plugins  in \~/.hal/default/service-settings/orca.yml


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.opsmx.com/opsmx-1/opsmx-context-engine/additional-resources/upgrading-to-3.7/upgrade-from-3.9.x-to-3.9.5.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
